<?php

/**
 * The file that defines the core plugin class
 *
 * A class definition that includes attributes and functions used across both the
 * public-facing side of the site and the admin area.
 *
 * @link       https://wedima.de
 * @since      1.0.0
 *
 * @package    Wedima_Site
 * @subpackage Wedima_Site/includes
 */

/**
 * The core plugin class.
 *
 * This is used to define internationalization, admin-specific hooks, and
 * public-facing site hooks.
 *
 * Also maintains the unique identifier of this plugin as well as the current
 * version of the plugin.
 *
 * @since      1.0.0
 * @package    Wedima_Site
 * @subpackage Wedima_Site/includes
 * @author     Jitendra Bodmann <jitendra.bodmann@wedima.de>
 */
class Wedima_Site
{

	/**
	 * The loader that's responsible for maintaining and registering all hooks that power
	 * the plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      Wedima_Site_Loader    $loader    Maintains and registers all hooks for the plugin.
	 */
	protected $loader;

	/**
	 * The unique identifier of this plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      string    $wedima_site    The string used to uniquely identify this plugin.
	 */
	protected $wedima_site;

	/**
	 * The current version of the plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      string    $version    The current version of the plugin.
	 */
	protected $version;

	/**
	 * Define the core functionality of the plugin.
	 *
	 * Set the plugin name and the plugin version that can be used throughout the plugin.
	 * Load the dependencies, define the locale, and set the hooks for the admin area and
	 * the public-facing side of the site.
	 *
	 * @since    1.0.0
	 */
	public function __construct()
	{
		if (defined('WEDIMA_SITE_VERSION')) {
			$this->version = WEDIMA_SITE_VERSION;
		} else {
			$this->version = '1.0.0';
		}
		$this->wedima_site = 'wedima-site';

		$this->load_dependencies();
		$this->set_locale();
		$this->define_admin_hooks();
		$this->define_public_hooks();
	}

	/**
	 * Load the required dependencies for this plugin.
	 *
	 * Include the following files that make up the plugin:
	 *
	 * - Wedima_Site_Loader. Orchestrates the hooks of the plugin.
	 * - Wedima_Site_i18n. Defines internationalization functionality.
	 * - Wedima_Site_Admin. Defines all hooks for the admin area.
	 * - Wedima_Site_Public. Defines all hooks for the public side of the site.
	 *
	 * Create an instance of the loader which will be used to register the hooks
	 * with WordPress.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function load_dependencies()
	{

		/**
		 * The class responsible for orchestrating the actions and filters of the
		 * core plugin.
		 */
		require_once plugin_dir_path(dirname(__FILE__)) . 'includes/class-wedima-site-loader.php';

		/**
		 * The class responsible for defining internationalization functionality
		 * of the plugin.
		 */
		require_once plugin_dir_path(dirname(__FILE__)) . 'includes/class-wedima-site-i18n.php';

		/**
		 * The class responsible for defining all actions that occur in the admin area.
		 */
		require_once plugin_dir_path(dirname(__FILE__)) . 'admin/class-wedima-site-admin.php';

		/**
		 * The class responsible for defining all actions that occur in the public-facing
		 * side of the site.
		 */
		require_once plugin_dir_path(dirname(__FILE__)) . 'public/class-wedima-site-public.php';

		$this->loader = new Wedima_Site_Loader();
	}

	/**
	 * Define the locale for this plugin for internationalization.
	 *
	 * Uses the Wedima_Site_i18n class in order to set the domain and to register the hook
	 * with WordPress.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function set_locale()
	{

		$plugin_i18n = new Wedima_Site_i18n();

		$this->loader->add_action('plugins_loaded', $plugin_i18n, 'load_plugin_textdomain');
	}

	/**
	 * Register all of the hooks related to the admin area functionality
	 * of the plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function define_admin_hooks()
	{
		$plugin_admin = new Wedima_Site_Admin($this->get_wedima_site(), $this->get_version());

		$this->loader->add_action('admin_enqueue_scripts', $plugin_admin, 'enqueue_styles');
		$this->loader->add_action('admin_enqueue_scripts', $plugin_admin, 'enqueue_scripts');

		// adds the admin menu
		$this->loader->add_action('admin_menu', $plugin_admin, 'wedima_site_admin_menu');
		// adds the admin settings
		$this->loader->add_action('admin_init', $plugin_admin, 'wedima_site_register_settings');
		// register the CLI commands
		$this->loader->add_action('cli_init', $plugin_admin, 'wedima_site_register_cli_commands');

		// mail
		if (get_option('wedima_site_disable_mail_templates', 0) != 1) {
			$this->loader->add_filter('wp_mail', $plugin_admin, 'wedima_site_redesign_mails', 10, 1);
			$this->loader->add_filter("wp_mail_content_type", $plugin_admin,  "wedima_site_change_mail_content_type");
			$this->loader->add_filter("retrieve_password_message", $plugin_admin, "wedima_site_retrieve_password_message", 10, 4);
			$this->loader->add_filter("wp_new_user_notification_email", $plugin_admin, 'wedima_site_new_user_notification_email', 10, 3);
		}

		// disable notifications for non admin users
		$this->loader->add_action('in_admin_header', $plugin_admin, 'wedima_site_hide_admin_notices', 99);
	}

	/**
	 * Register all of the hooks related to the public-facing functionality
	 * of the plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function define_public_hooks()
	{

		$plugin_public = new Wedima_Site_Public($this->get_wedima_site(), $this->get_version());

		$this->loader->add_action('wp_enqueue_scripts', $plugin_public, 'enqueue_styles');
		$this->loader->add_action('wp_enqueue_scripts', $plugin_public, 'enqueue_scripts');

		// disable login language switcher
		$this->loader->add_filter('login_display_language_dropdown', $plugin_public, 'wedima_site_login_language_switcher');

		// maintenance mode
		if (get_option('wedima_site_maintenance_mode', 0) != 0) {
			$this->loader->add_action('get_header', $plugin_public, 'wedima_site_maintenance');
		}

		// shortcodes
		$this->loader->add_shortcode('wedima_site_date', $plugin_public, 'shortcode_wedima_site_date');
		$this->loader->add_shortcode('wedima_site_credits', $plugin_public, 'shortcode_wedima_site_credits');
		$this->loader->add_shortcode('wedima_site_copyright', $plugin_public, 'shortcode_wedima_site_copyright');
	}

	/**
	 * Run the loader to execute all of the hooks with WordPress.
	 *
	 * @since    1.0.0
	 */
	public function run()
	{
		$this->loader->run();
	}

	/**
	 * The name of the plugin used to uniquely identify it within the context of
	 * WordPress and to define internationalization functionality.
	 *
	 * @since     1.0.0
	 * @return    string    The name of the plugin.
	 */
	public function get_wedima_site()
	{
		return $this->wedima_site;
	}

	/**
	 * The reference to the class that orchestrates the hooks with the plugin.
	 *
	 * @since     1.0.0
	 * @return    Wedima_Site_Loader    Orchestrates the hooks of the plugin.
	 */
	public function get_loader()
	{
		return $this->loader;
	}

	/**
	 * Retrieve the version number of the plugin.
	 *
	 * @since     1.0.0
	 * @return    string    The version number of the plugin.
	 */
	public function get_version()
	{
		return $this->version;
	}
}
